OBJS += exec/io.o exec/marching.o exec/main.o

EXEC_IOHELPERS_HPP = exec/iohelpers.hpp
EXEC_IO_HPP = exec/io.hpp $(SIM_SIMULATOR_HPP)
EXEC_MARCHING_HPP = exec/marching.hpp $(COMMON_HPP) $(MATH_FIELDS_HPP)
EXEC_RENDERER_HPP = exec/renderer.hpp $(SIM_SIMULATOR_HPP)
EXEC_RENDER3R_HPP = exec/render3r.hpp $(EXEC_RENDERER_HPP)
EXEC_RIHELPERS_HPP = exec/rihelpers.hpp

bin/sand: $(OBJS)
	$(LINK) $(OBJS) $(DEPS) -o $@

exec/main.o: exec/main.cpp $(COMMON_HPP) $(SIM_SIMULATOR_HPP) $(MODEL_PRIMITIVE_HPP) $(MODEL_VOXELIZER_HPP) $(MODEL_DISTANCE_HPP) $(EXEC_IO_HPP) $(EXEC_IOHELPERS_HPP) $(EXEC_RENDERER_HPP)
	$(COMPILE) $< -o $@

exec/io.o: exec/io.cpp $(EXEC_IO_HPP) $(EXEC_IOHELPERS_HPP) $(SIM_PARTICLE_HPP) $(SIM_SCRIPTED_HPP) $(MODEL_PRIMITIVE_HPP)
	$(COMPILE) $< -o $@

exec/marching.o: exec/marching.cpp $(EXEC_MARCHING_HPP)
	$(COMPILE) $< -o $@

#exec/renderer2.o: exec/renderer2.cpp $(EXEC_RENDERER_HPP) $(EXEC_IO_HPP) $(EXEC_IOHELPERS_HPP) $(EXEC_MARCHING_HPP)
#	$(COMPILE) $< -o $@

#exec/renderer3.o: exec/renderer3.cpp $(EXEC_RENDERER_HPP) $(EXEC_IO_HPP) $(EXEC_IOHELPERS_HPP)
#	$(COMPILE) $< -o $@

#exec/render3r.o: exec/render3r.cpp $(EXEC_RENDER3R_HPP) $(EXEC_RIHELPERS_HPP) $(EXEC_IO_HPP) $(EXEC_IOHELPERS_HPP)
#	$(COMPILE) $< -o $@

#exec/rihelpers.o: exec/rihelpers.cpp $(EXEC_RENDER3R_HPP) $(EXEC_IO_HPP) $(EXEC_IOHELPERS_HPP)
#	$(COMPILE) $< -o $@
