#pragma once

#ifndef __MATRIXS_H__
#define __MATRIXS_H__

#include "../common.hpp"
#include <vector>
#include <cstdio>
#include <mkl_cblas.h>

using namespace std;

/// Stupid general matrix
template <class T>
class MatrixS
{
public:
	int m, n;
	vector<T> s;   // x-major order
	inline void resize (int m, int n) {
		this->m = m;
		this->n = n;
		s.resize(m*n);
	}
	inline T operator() (int i, int j) const {return s[i+j*m];}
	inline T &operator() (int i, int j) {return s[i+j*m];}
	inline void set_all (T f) {
		s.assign(s.size(), f);
	}
	void writeMatlab(char *filename, char *variable) {
		FILE *file = fopen(filename, "w");
			fprintf(file,"%s = [",variable);
			for ( int x = 0; x < m; x++ ) {
				for ( int y = 0; y < n; y++ ) {
					fprintf(file, "%f ",operator()(x, y));
				}
				if(x < m - 1) fprintf(file, ";");
			}
			fprintf(file,"];\n");
		fclose(file);
	}
};

/// Broken functions, must be fixed before use
void multiplyMatrixS(MatrixS<float> &dest, MatrixS<float> &src1, MatrixS<float> &src2);
void multiplyMatrixS(MatrixS<double> &dest, MatrixS<double> &src1, MatrixS<double> &src2);

#endif