#include "voxelizer.hpp"
#include "voxel_file_format.h"
#include <fstream>
using namespace std;

void load_voxels (const string &filename, ScalarField<3> &voxels) {
	fstream file(filename.c_str(), ios::in|ios::binary);
	voxelfile_file_header fh;
	file.read((char*)&fh, sizeof(fh));
	voxelfile_object_header oh;
	file.read((char*)&oh, sizeof(oh));
	cout << oh.num_voxels << " voxels" << endl;
	cout << "Voxel resolution " << oh.voxel_resolution[0] << "x" << oh.voxel_resolution[1] << "x" << oh.voxel_resolution[2] << endl;
	cout << "Voxel size " << oh.voxel_size[0] << "x" << oh.voxel_size[1] << "x" << oh.voxel_size[2] << endl;
	cout << "Model scale factor " <<oh.model_scale_factor << endl;
	int m = oh.voxel_resolution[0], n = oh.voxel_resolution[1], o = oh.voxel_resolution[2];
	voxels.resize(m,n,o, oh.voxel_size[0]/oh.model_scale_factor);
	set_all(voxels, 0);
	for (int v = 0; v < m*n*o; v++) {
		char type;
		file.read((char*)&type, 1);
		if (type != ASCIIVOXEL_NOVOXEL) {
			voxelfile_voxel voxel;
			file.read((char*)&voxel, sizeof(voxel));
			voxels(voxel.i,voxel.j,voxel.k) = 1;
		}
	}
	cout << "Final size " << voxels.m*voxels.dx << " " << voxels.n*voxels.dx << " " << voxels.o*voxels.dx << endl;
}
