/* I took wave's lead and renamed plastic to DPPlastic.sl -- tal AT renderman DOT org */

/* 
 * plastic.sl
 *
 * AUTHOR: Darwyn Peachy
 *
 * REFERENCES:
 *    _Texturing and Modeling: A Procedural Approach_, by David S. Ebert, ed.,
 *    F. Kenton Musgrave, Darwyn Peachey, Ken Perlin, and Steven Worley.
 *    Academic Press, 1994.  ISBN 0-12-228760-6.
 */
 
surface
DPPlastic(float Ka = 1, Kd = 0.5, Ks = 0.5;
        float roughness = 0.1;
        color specularcolor = color (1,1,1))
{
    normal Nf = faceforward(normalize(N), I);
    vector V = normalize(-I);

    Oi = Os;
    Ci = Os * (Cs * (Ka * ambient() + Kd * diffuse(Nf))
         + specularcolor * Ks * specular(Nf, V, roughness));
}
