OBJS += sim/particle.o sim/rigid.o sim/coupling.o sim/friction.o sim/pressure.o sim/sand.o sim/simulator.o sim/scripted.o sim/zhubridson.o

SIM_PARTICLE_HPP = sim/particle.hpp $(COMMON_HPP)
SIM_SAND_HPP = sim/sand.hpp $(COMMON_HPP) $(MATH_FIELDS_HPP) $(SIM_PARTICLE_HPP)
SIM_RIGID_HPP = sim/rigid.hpp $(COMMON_HPP) $(MATH_FIELDS_HPP) $(SIM_PARTICLE_HPP)
SIM_OBSTACLES_HPP = sim/obstacles.hpp $(SIM_RIGID_HPP)
SIM_SIMHELPERS_HPP = sim/simhelpers.hpp $(SIM_SAND_HPP)
SIM_COUPLING_HPP = sim/coupling.hpp $(SIM_RIGID_HPP) $(SIM_SAND_HPP) $(SIM_SIMHELPERS_HPP)
SIM_FRICTION_HPP = sim/friction.hpp $(SIM_SAND_HPP) $(SIM_RIGID_HPP)
SIM_PRESSURE_HPP = sim/pressure.hpp $(SIM_SAND_HPP) $(SIM_RIGID_HPP)
SIM_SIMULATOR_HPP = sim/simulator.hpp $(COMMON_HPP) $(MATH_FIELDS_HPP) $(SIM_SAND_HPP) $(SIM_RIGID_HPP)
SIM_SCRIPTED_HPP = sim/scripted.hpp $(COMMON_HPP) $(SIM_RIGID_HPP)
SIM_ZHUBRIDSON_HPP = sim/zhubridson.hpp $(SIM_SAND_HPP)

sim/particle.o: sim/particle.cpp $(SIM_PARTICLE_HPP)
	$(COMPILE) $< -o $@

sim/rigid.o: sim/rigid.cpp $(SIM_RIGID_HPP)
	$(COMPILE) $< -o $@

sim/coupling.o: sim/coupling.cpp $(SIM_COUPLING_HPP)
	$(COMPILE) $< -o $@

sim/friction.o: sim/friction.cpp $(SIM_FRICTION_HPP) $(MATH_QP_HPP) $(SIM_COUPLING_HPP) $(SIM_SIMHELPERS_HPP)
	$(COMPILE) $< -o $@

sim/pressure.o: sim/pressure.cpp $(SIM_PRESSURE_HPP) $(MATH_QP_HPP) $(SIM_COUPLING_HPP) $(SIM_SIMHELPERS_HPP)
	$(COMPILE) $< -o $@

sim/sand.o: sim/sand.cpp $(SIM_SAND_HPP)
	$(COMPILE) $< -o $@

sim/simulator.o: sim/simulator.cpp $(SIM_SIMULATOR_HPP) $(SIM_PRESSURE_HPP) $(SIM_FRICTION_HPP) $(SIM_SCRIPTED_HPP)
	$(COMPILE) $< -o $@

sim/scripted.o: sim/scripted.cpp $(SIM_SCRIPTED_HPP) $(SIM_SIMULATOR_HPP)
	$(COMPILE) $< -o $@

sim/zhubridson.o: sim/zhubridson.cpp $(SIM_ZHUBRIDSON_HPP) $(MATH_QP_HPP) $(SIM_SIMHELPERS_HPP) $(SIM_RIGID_HPP)
	$(COMPILE) $< -o $@
